# coding: utf-8

"""
    DDOTS RESTful API Server

    ## Explore the demo server  I suggest you start with signing up a new user. To do so, use `POST /users/` endpoint with `recaptcha_key=\"secret_key\"`.  You will need to know the API Client ID to authenticate, so here it is: `documentation`. Sometimes (e.g. for token refreshing) you might need API Client Secret: `KQ()SWK)SQK)QWSKQW(SKQ)S(QWSQW(SJ*HQ&HQW*SQ*^SSQWSGQSG`.  There are also two built-in users: * `root` (administrator with all permissions) with password `q` * `user` (regular user) with password `w` 

    OpenAPI spec version: 0.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..api_client import ApiClient


class ProblemsApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_problem(self, title, tests_archive, **kwargs):
        """
        Create a new problem
        **PERMISSIONS: At least Active user is required.**
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_problem(title, tests_archive, async=True)
        >>> result = thread.get()

        :param async bool
        :param str title: (required)
        :param file tests_archive: `.tar.gz` archive with Problem.xml and related files. (required)
        :param str description:
        :return: DetailedProblem
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.create_problem_with_http_info(title, tests_archive, **kwargs)
        else:
            (data) = self.create_problem_with_http_info(title, tests_archive, **kwargs)
            return data

    def create_problem_with_http_info(self, title, tests_archive, **kwargs):
        """
        Create a new problem
        **PERMISSIONS: At least Active user is required.**
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_problem_with_http_info(title, tests_archive, async=True)
        >>> result = thread.get()

        :param async bool
        :param str title: (required)
        :param file tests_archive: `.tar.gz` archive with Problem.xml and related files. (required)
        :param str description:
        :return: DetailedProblem
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['title', 'tests_archive', 'description']
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_problem" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'title' is set
        if ('title' not in params) or (params['title'] is None):
            raise ValueError("Missing the required parameter `title` when calling `create_problem`")
        # verify the required parameter 'tests_archive' is set
        if ('tests_archive' not in params) or (params['tests_archive'] is None):
            raise ValueError("Missing the required parameter `tests_archive` when calling `create_problem`")

        if 'title' in params and len(params['title']) > 100:
            raise ValueError("Invalid value for parameter `title` when calling `create_problem`, length must be less than or equal to `100`")

        collection_formats = {}

        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}
        if 'title' in params:
            form_params.append(('title', params['title']))
        if 'description' in params:
            form_params.append(('description', params['description']))
        if 'tests_archive' in params:
            local_var_files['tests_archive'] = params['tests_archive']

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['multipart/form-data'])

        # Authentication setting
        auth_settings = ['oauth2_password']

        return self.api_client.call_api('/problems/', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='DetailedProblem',
                                        auth_settings=auth_settings,
                                        async=params.get('async'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def delete_problem_by_id(self, problem_id, **kwargs):
        """
        Delete a problem by ID
        **PERMISSIONS: Owner/Supervisor/Admin may execute this action.**
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.delete_problem_by_id(problem_id, async=True)
        >>> result = thread.get()

        :param async bool
        :param int problem_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.delete_problem_by_id_with_http_info(problem_id, **kwargs)
        else:
            (data) = self.delete_problem_by_id_with_http_info(problem_id, **kwargs)
            return data

    def delete_problem_by_id_with_http_info(self, problem_id, **kwargs):
        """
        Delete a problem by ID
        **PERMISSIONS: Owner/Supervisor/Admin may execute this action.**
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.delete_problem_by_id_with_http_info(problem_id, async=True)
        >>> result = thread.get()

        :param async bool
        :param int problem_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['problem_id']
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_problem_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'problem_id' is set
        if ('problem_id' not in params) or (params['problem_id'] is None):
            raise ValueError("Missing the required parameter `problem_id` when calling `delete_problem_by_id`")


        collection_formats = {}

        path_params = {}
        if 'problem_id' in params:
            path_params['problem_id'] = params['problem_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['oauth2_password']

        return self.api_client.call_api('/problems/{problem_id}', 'DELETE',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        async=params.get('async'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def get_problem_by_id(self, problem_id, **kwargs):
        """
        Get problem details by ID
        **PERMISSIONS: Owner/Supervisor/Admin may execute this action.**
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_problem_by_id(problem_id, async=True)
        >>> result = thread.get()

        :param async bool
        :param int problem_id: (required)
        :return: DetailedProblem
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_problem_by_id_with_http_info(problem_id, **kwargs)
        else:
            (data) = self.get_problem_by_id_with_http_info(problem_id, **kwargs)
            return data

    def get_problem_by_id_with_http_info(self, problem_id, **kwargs):
        """
        Get problem details by ID
        **PERMISSIONS: Owner/Supervisor/Admin may execute this action.**
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_problem_by_id_with_http_info(problem_id, async=True)
        >>> result = thread.get()

        :param async bool
        :param int problem_id: (required)
        :return: DetailedProblem
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['problem_id']
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_problem_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'problem_id' is set
        if ('problem_id' not in params) or (params['problem_id'] is None):
            raise ValueError("Missing the required parameter `problem_id` when calling `get_problem_by_id`")


        collection_formats = {}

        path_params = {}
        if 'problem_id' in params:
            path_params['problem_id'] = params['problem_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['oauth2_password']

        return self.api_client.call_api('/problems/{problem_id}', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='DetailedProblem',
                                        auth_settings=auth_settings,
                                        async=params.get('async'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def get_problem_tests_archive_by_id(self, problem_id, **kwargs):
        """
        Get problem tests archive by ID
        **PERMISSIONS: Owner/Supervisor/Admin may execute this action.**
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_problem_tests_archive_by_id(problem_id, async=True)
        >>> result = thread.get()

        :param async bool
        :param int problem_id: (required)
        :return: ProblemTestsArchiveSchema
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_problem_tests_archive_by_id_with_http_info(problem_id, **kwargs)
        else:
            (data) = self.get_problem_tests_archive_by_id_with_http_info(problem_id, **kwargs)
            return data

    def get_problem_tests_archive_by_id_with_http_info(self, problem_id, **kwargs):
        """
        Get problem tests archive by ID
        **PERMISSIONS: Owner/Supervisor/Admin may execute this action.**
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_problem_tests_archive_by_id_with_http_info(problem_id, async=True)
        >>> result = thread.get()

        :param async bool
        :param int problem_id: (required)
        :return: ProblemTestsArchiveSchema
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['problem_id']
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_problem_tests_archive_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'problem_id' is set
        if ('problem_id' not in params) or (params['problem_id'] is None):
            raise ValueError("Missing the required parameter `problem_id` when calling `get_problem_tests_archive_by_id`")


        collection_formats = {}

        path_params = {}
        if 'problem_id' in params:
            path_params['problem_id'] = params['problem_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['oauth2_password']

        return self.api_client.call_api('/problems/{problem_id}/tests.tar.gz', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ProblemTestsArchiveSchema',
                                        auth_settings=auth_settings,
                                        async=params.get('async'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def get_problems(self, **kwargs):
        """
        List of problems
        **PERMISSIONS: At least Active user is required.**   Returns a list of problems starting from ``offset`` limited by ``limit`` parameter.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_problems(async=True)
        >>> result = thread.get()

        :param async bool
        :param int limit: limit a number of items (allowed range is 1-100), default is 20.
        :param int offset: a number of items to skip, default is 0.
        :return: list[BaseProblem]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_problems_with_http_info(**kwargs)
        else:
            (data) = self.get_problems_with_http_info(**kwargs)
            return data

    def get_problems_with_http_info(self, **kwargs):
        """
        List of problems
        **PERMISSIONS: At least Active user is required.**   Returns a list of problems starting from ``offset`` limited by ``limit`` parameter.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_problems_with_http_info(async=True)
        >>> result = thread.get()

        :param async bool
        :param int limit: limit a number of items (allowed range is 1-100), default is 20.
        :param int offset: a number of items to skip, default is 0.
        :return: list[BaseProblem]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['limit', 'offset']
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_problems" % key
                )
            params[key] = val
        del params['kwargs']

        if 'limit' in params and params['limit'] > 100:
            raise ValueError("Invalid value for parameter `limit` when calling `get_problems`, must be a value less than or equal to `100`")
        if 'limit' in params and params['limit'] < 1:
            raise ValueError("Invalid value for parameter `limit` when calling `get_problems`, must be a value greater than or equal to `1`")
        if 'offset' in params and params['offset'] < 0:
            raise ValueError("Invalid value for parameter `offset` when calling `get_problems`, must be a value greater than or equal to `0`")

        collection_formats = {}

        path_params = {}

        query_params = {}
        if 'limit' in params:
            query_params['limit'] = params['limit']
        if 'offset' in params:
            query_params['offset'] = params['offset']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['oauth2_password']

        return self.api_client.call_api('/problems/', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='list[BaseProblem]',
                                        auth_settings=auth_settings,
                                        async=params.get('async'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def options_problem_by_id(self, problem_id, **kwargs):
        """
        Check which methods are allowed
        **PERMISSIONS: At least Active user is required.**   Use this method if you need to know what operations are allowed to be performed on this endpoint, e.g. to decide wether to display a button in your UI.  The list of allowed methods is provided in `Allow` response header.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.options_problem_by_id(problem_id, async=True)
        >>> result = thread.get()

        :param async bool
        :param int problem_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.options_problem_by_id_with_http_info(problem_id, **kwargs)
        else:
            (data) = self.options_problem_by_id_with_http_info(problem_id, **kwargs)
            return data

    def options_problem_by_id_with_http_info(self, problem_id, **kwargs):
        """
        Check which methods are allowed
        **PERMISSIONS: At least Active user is required.**   Use this method if you need to know what operations are allowed to be performed on this endpoint, e.g. to decide wether to display a button in your UI.  The list of allowed methods is provided in `Allow` response header.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.options_problem_by_id_with_http_info(problem_id, async=True)
        >>> result = thread.get()

        :param async bool
        :param int problem_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['problem_id']
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method options_problem_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'problem_id' is set
        if ('problem_id' not in params) or (params['problem_id'] is None):
            raise ValueError("Missing the required parameter `problem_id` when calling `options_problem_by_id`")


        collection_formats = {}

        path_params = {}
        if 'problem_id' in params:
            path_params['problem_id'] = params['problem_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['oauth2_password']

        return self.api_client.call_api('/problems/{problem_id}', 'OPTIONS',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        async=params.get('async'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def options_problem_tests_archive_by_id(self, problem_id, **kwargs):
        """
        Check which methods are allowed
        **PERMISSIONS: At least Active user is required.**   Use this method if you need to know what operations are allowed to be performed on this endpoint, e.g. to decide wether to display a button in your UI.  The list of allowed methods is provided in `Allow` response header.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.options_problem_tests_archive_by_id(problem_id, async=True)
        >>> result = thread.get()

        :param async bool
        :param int problem_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.options_problem_tests_archive_by_id_with_http_info(problem_id, **kwargs)
        else:
            (data) = self.options_problem_tests_archive_by_id_with_http_info(problem_id, **kwargs)
            return data

    def options_problem_tests_archive_by_id_with_http_info(self, problem_id, **kwargs):
        """
        Check which methods are allowed
        **PERMISSIONS: At least Active user is required.**   Use this method if you need to know what operations are allowed to be performed on this endpoint, e.g. to decide wether to display a button in your UI.  The list of allowed methods is provided in `Allow` response header.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.options_problem_tests_archive_by_id_with_http_info(problem_id, async=True)
        >>> result = thread.get()

        :param async bool
        :param int problem_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['problem_id']
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method options_problem_tests_archive_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'problem_id' is set
        if ('problem_id' not in params) or (params['problem_id'] is None):
            raise ValueError("Missing the required parameter `problem_id` when calling `options_problem_tests_archive_by_id`")


        collection_formats = {}

        path_params = {}
        if 'problem_id' in params:
            path_params['problem_id'] = params['problem_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['oauth2_password']

        return self.api_client.call_api('/problems/{problem_id}/tests.tar.gz', 'OPTIONS',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        async=params.get('async'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def options_problems(self, **kwargs):
        """
        Check which methods are allowed
        **PERMISSIONS: At least Active user is required.**   Use this method if you need to know what operations are allowed to be performed on this endpoint, e.g. to decide wether to display a button in your UI.  The list of allowed methods is provided in `Allow` response header.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.options_problems(async=True)
        >>> result = thread.get()

        :param async bool
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.options_problems_with_http_info(**kwargs)
        else:
            (data) = self.options_problems_with_http_info(**kwargs)
            return data

    def options_problems_with_http_info(self, **kwargs):
        """
        Check which methods are allowed
        **PERMISSIONS: At least Active user is required.**   Use this method if you need to know what operations are allowed to be performed on this endpoint, e.g. to decide wether to display a button in your UI.  The list of allowed methods is provided in `Allow` response header.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.options_problems_with_http_info(async=True)
        >>> result = thread.get()

        :param async bool
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method options_problems" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['oauth2_password']

        return self.api_client.call_api('/problems/', 'OPTIONS',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        async=params.get('async'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def patch_problem_by_id(self, problem_id, body, **kwargs):
        """
        Patch problem details by ID
        **PERMISSIONS: Owner/Supervisor/Admin may execute this action.**
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.patch_problem_by_id(problem_id, body, async=True)
        >>> result = thread.get()

        :param async bool
        :param int problem_id: (required)
        :param list[Body] body: (required)
        :return: DetailedProblem
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.patch_problem_by_id_with_http_info(problem_id, body, **kwargs)
        else:
            (data) = self.patch_problem_by_id_with_http_info(problem_id, body, **kwargs)
            return data

    def patch_problem_by_id_with_http_info(self, problem_id, body, **kwargs):
        """
        Patch problem details by ID
        **PERMISSIONS: Owner/Supervisor/Admin may execute this action.**
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.patch_problem_by_id_with_http_info(problem_id, body, async=True)
        >>> result = thread.get()

        :param async bool
        :param int problem_id: (required)
        :param list[Body] body: (required)
        :return: DetailedProblem
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['problem_id', 'body']
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method patch_problem_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'problem_id' is set
        if ('problem_id' not in params) or (params['problem_id'] is None):
            raise ValueError("Missing the required parameter `problem_id` when calling `patch_problem_by_id`")
        # verify the required parameter 'body' is set
        if ('body' not in params) or (params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `patch_problem_by_id`")


        collection_formats = {}

        path_params = {}
        if 'problem_id' in params:
            path_params['problem_id'] = params['problem_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['oauth2_password']

        return self.api_client.call_api('/problems/{problem_id}', 'PATCH',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='DetailedProblem',
                                        auth_settings=auth_settings,
                                        async=params.get('async'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)
