# coding: utf-8

"""
    DDOTS RESTful API Server

    ## Explore the demo server  I suggest you start with signing up a new user. To do so, use `POST /users/` endpoint with `recaptcha_key=\"secret_key\"`.  You will need to know the API Client ID to authenticate, so here it is: `documentation`. Sometimes (e.g. for token refreshing) you might need API Client Secret: `KQ()SWK)SQK)QWSKQW(SKQ)S(QWSQW(SJ*HQ&HQW*SQ*^SSQWSGQSG`.  There are also two built-in users: * `root` (administrator with all permissions) with password `q` * `user` (regular user) with password `w` 

    OpenAPI spec version: 0.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..api_client import ApiClient


class ProgrammingLanguagesApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def delete_programming_language_by_name(self, programming_language_name, **kwargs):
        """
        Delete a programming language by ID
        **PERMISSIONS: Admin role is required.**
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.delete_programming_language_by_name(programming_language_name, async=True)
        >>> result = thread.get()

        :param async bool
        :param str programming_language_name: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.delete_programming_language_by_name_with_http_info(programming_language_name, **kwargs)
        else:
            (data) = self.delete_programming_language_by_name_with_http_info(programming_language_name, **kwargs)
            return data

    def delete_programming_language_by_name_with_http_info(self, programming_language_name, **kwargs):
        """
        Delete a programming language by ID
        **PERMISSIONS: Admin role is required.**
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.delete_programming_language_by_name_with_http_info(programming_language_name, async=True)
        >>> result = thread.get()

        :param async bool
        :param str programming_language_name: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['programming_language_name']
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_programming_language_by_name" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'programming_language_name' is set
        if ('programming_language_name' not in params) or (params['programming_language_name'] is None):
            raise ValueError("Missing the required parameter `programming_language_name` when calling `delete_programming_language_by_name`")


        collection_formats = {}

        path_params = {}
        if 'programming_language_name' in params:
            path_params['programming_language_name'] = params['programming_language_name']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['oauth2_password']

        return self.api_client.call_api('/programming-languages/{programming_language_name}', 'DELETE',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        async=params.get('async'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def get_programming_language_by_name(self, programming_language_name, **kwargs):
        """
        Get programming language details by ID
        **PERMISSIONS: Admin role is required.**
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_programming_language_by_name(programming_language_name, async=True)
        >>> result = thread.get()

        :param async bool
        :param str programming_language_name: (required)
        :return: DetailedProgrammingLanguage
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_programming_language_by_name_with_http_info(programming_language_name, **kwargs)
        else:
            (data) = self.get_programming_language_by_name_with_http_info(programming_language_name, **kwargs)
            return data

    def get_programming_language_by_name_with_http_info(self, programming_language_name, **kwargs):
        """
        Get programming language details by ID
        **PERMISSIONS: Admin role is required.**
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_programming_language_by_name_with_http_info(programming_language_name, async=True)
        >>> result = thread.get()

        :param async bool
        :param str programming_language_name: (required)
        :return: DetailedProgrammingLanguage
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['programming_language_name']
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_programming_language_by_name" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'programming_language_name' is set
        if ('programming_language_name' not in params) or (params['programming_language_name'] is None):
            raise ValueError("Missing the required parameter `programming_language_name` when calling `get_programming_language_by_name`")


        collection_formats = {}

        path_params = {}
        if 'programming_language_name' in params:
            path_params['programming_language_name'] = params['programming_language_name']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['oauth2_password']

        return self.api_client.call_api('/programming-languages/{programming_language_name}', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='DetailedProgrammingLanguage',
                                        auth_settings=auth_settings,
                                        async=params.get('async'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def get_programming_languages(self, **kwargs):
        """
        List of programming languages
        **PERMISSIONS: At least Active user is required.**   Returns a list of programming languages starting from ``offset`` limited by ``limit`` parameter.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_programming_languages(async=True)
        >>> result = thread.get()

        :param async bool
        :param int limit: limit a number of items (allowed range is 1-100), default is 20.
        :param int offset: a number of items to skip, default is 0.
        :return: list[BaseProgrammingLanguage]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_programming_languages_with_http_info(**kwargs)
        else:
            (data) = self.get_programming_languages_with_http_info(**kwargs)
            return data

    def get_programming_languages_with_http_info(self, **kwargs):
        """
        List of programming languages
        **PERMISSIONS: At least Active user is required.**   Returns a list of programming languages starting from ``offset`` limited by ``limit`` parameter.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_programming_languages_with_http_info(async=True)
        >>> result = thread.get()

        :param async bool
        :param int limit: limit a number of items (allowed range is 1-100), default is 20.
        :param int offset: a number of items to skip, default is 0.
        :return: list[BaseProgrammingLanguage]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['limit', 'offset']
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_programming_languages" % key
                )
            params[key] = val
        del params['kwargs']

        if 'limit' in params and params['limit'] > 100:
            raise ValueError("Invalid value for parameter `limit` when calling `get_programming_languages`, must be a value less than or equal to `100`")
        if 'limit' in params and params['limit'] < 1:
            raise ValueError("Invalid value for parameter `limit` when calling `get_programming_languages`, must be a value greater than or equal to `1`")
        if 'offset' in params and params['offset'] < 0:
            raise ValueError("Invalid value for parameter `offset` when calling `get_programming_languages`, must be a value greater than or equal to `0`")

        collection_formats = {}

        path_params = {}

        query_params = {}
        if 'limit' in params:
            query_params['limit'] = params['limit']
        if 'offset' in params:
            query_params['offset'] = params['offset']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['oauth2_password']

        return self.api_client.call_api('/programming-languages/', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='list[BaseProgrammingLanguage]',
                                        auth_settings=auth_settings,
                                        async=params.get('async'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def options_programming_language_by_name(self, programming_language_name, **kwargs):
        """
        Check which methods are allowed
        **PERMISSIONS: At least Active user is required.**   Use this method if you need to know what operations are allowed to be performed on this endpoint, e.g. to decide wether to display a button in your UI.  The list of allowed methods is provided in `Allow` response header.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.options_programming_language_by_name(programming_language_name, async=True)
        >>> result = thread.get()

        :param async bool
        :param str programming_language_name: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.options_programming_language_by_name_with_http_info(programming_language_name, **kwargs)
        else:
            (data) = self.options_programming_language_by_name_with_http_info(programming_language_name, **kwargs)
            return data

    def options_programming_language_by_name_with_http_info(self, programming_language_name, **kwargs):
        """
        Check which methods are allowed
        **PERMISSIONS: At least Active user is required.**   Use this method if you need to know what operations are allowed to be performed on this endpoint, e.g. to decide wether to display a button in your UI.  The list of allowed methods is provided in `Allow` response header.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.options_programming_language_by_name_with_http_info(programming_language_name, async=True)
        >>> result = thread.get()

        :param async bool
        :param str programming_language_name: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['programming_language_name']
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method options_programming_language_by_name" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'programming_language_name' is set
        if ('programming_language_name' not in params) or (params['programming_language_name'] is None):
            raise ValueError("Missing the required parameter `programming_language_name` when calling `options_programming_language_by_name`")


        collection_formats = {}

        path_params = {}
        if 'programming_language_name' in params:
            path_params['programming_language_name'] = params['programming_language_name']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['oauth2_password']

        return self.api_client.call_api('/programming-languages/{programming_language_name}', 'OPTIONS',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        async=params.get('async'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def options_programming_languages(self, **kwargs):
        """
        Check which methods are allowed
        **PERMISSIONS: At least Active user is required.**   Use this method if you need to know what operations are allowed to be performed on this endpoint, e.g. to decide wether to display a button in your UI.  The list of allowed methods is provided in `Allow` response header.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.options_programming_languages(async=True)
        >>> result = thread.get()

        :param async bool
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.options_programming_languages_with_http_info(**kwargs)
        else:
            (data) = self.options_programming_languages_with_http_info(**kwargs)
            return data

    def options_programming_languages_with_http_info(self, **kwargs):
        """
        Check which methods are allowed
        **PERMISSIONS: At least Active user is required.**   Use this method if you need to know what operations are allowed to be performed on this endpoint, e.g. to decide wether to display a button in your UI.  The list of allowed methods is provided in `Allow` response header.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.options_programming_languages_with_http_info(async=True)
        >>> result = thread.get()

        :param async bool
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method options_programming_languages" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['oauth2_password']

        return self.api_client.call_api('/programming-languages/', 'OPTIONS',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        async=params.get('async'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def patch_programming_language_by_name(self, programming_language_name, body, **kwargs):
        """
        Patch programming language details by name
        **PERMISSIONS: Admin role is required.**
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.patch_programming_language_by_name(programming_language_name, body, async=True)
        >>> result = thread.get()

        :param async bool
        :param str programming_language_name: (required)
        :param list[Body1] body: (required)
        :return: DetailedProgrammingLanguage
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.patch_programming_language_by_name_with_http_info(programming_language_name, body, **kwargs)
        else:
            (data) = self.patch_programming_language_by_name_with_http_info(programming_language_name, body, **kwargs)
            return data

    def patch_programming_language_by_name_with_http_info(self, programming_language_name, body, **kwargs):
        """
        Patch programming language details by name
        **PERMISSIONS: Admin role is required.**
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.patch_programming_language_by_name_with_http_info(programming_language_name, body, async=True)
        >>> result = thread.get()

        :param async bool
        :param str programming_language_name: (required)
        :param list[Body1] body: (required)
        :return: DetailedProgrammingLanguage
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['programming_language_name', 'body']
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method patch_programming_language_by_name" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'programming_language_name' is set
        if ('programming_language_name' not in params) or (params['programming_language_name'] is None):
            raise ValueError("Missing the required parameter `programming_language_name` when calling `patch_programming_language_by_name`")
        # verify the required parameter 'body' is set
        if ('body' not in params) or (params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `patch_programming_language_by_name`")


        collection_formats = {}

        path_params = {}
        if 'programming_language_name' in params:
            path_params['programming_language_name'] = params['programming_language_name']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['oauth2_password']

        return self.api_client.call_api('/programming-languages/{programming_language_name}', 'PATCH',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='DetailedProgrammingLanguage',
                                        auth_settings=auth_settings,
                                        async=params.get('async'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def post_programming_languages(self, **kwargs):
        """
        Upload a new programming language
        **PERMISSIONS: At least Active user is required.**
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.post_programming_languages(async=True)
        >>> result = thread.get()

        :param async bool
        :param str name:
        :param str title:
        :param str version:
        :param str compiler_docker_image_name:
        :param str executor_docker_image_name:
        :return: DetailedProgrammingLanguage
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.post_programming_languages_with_http_info(**kwargs)
        else:
            (data) = self.post_programming_languages_with_http_info(**kwargs)
            return data

    def post_programming_languages_with_http_info(self, **kwargs):
        """
        Upload a new programming language
        **PERMISSIONS: At least Active user is required.**
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.post_programming_languages_with_http_info(async=True)
        >>> result = thread.get()

        :param async bool
        :param str name:
        :param str title:
        :param str version:
        :param str compiler_docker_image_name:
        :param str executor_docker_image_name:
        :return: DetailedProgrammingLanguage
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['name', 'title', 'version', 'compiler_docker_image_name', 'executor_docker_image_name']
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_programming_languages" % key
                )
            params[key] = val
        del params['kwargs']


        collection_formats = {}

        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}
        if 'name' in params:
            form_params.append(('name', params['name']))
        if 'title' in params:
            form_params.append(('title', params['title']))
        if 'version' in params:
            form_params.append(('version', params['version']))
        if 'compiler_docker_image_name' in params:
            form_params.append(('compiler_docker_image_name', params['compiler_docker_image_name']))
        if 'executor_docker_image_name' in params:
            form_params.append(('executor_docker_image_name', params['executor_docker_image_name']))

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/x-www-form-urlencoded', 'multipart/form-data'])

        # Authentication setting
        auth_settings = ['oauth2_password']

        return self.api_client.call_api('/programming-languages/', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='DetailedProgrammingLanguage',
                                        auth_settings=auth_settings,
                                        async=params.get('async'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)
